class SPIBus:

    def __init__(
        self,
        *,
        spi_bus: machine.SPI.Bus,
        dc: int,
        freq: int,
        cs: int = -1,
        dc_low_on_data: bool = False,
        lsb_first: bool = False,
        cs_high_active: bool = False,
        spi_mode: int = 0,
        dual: bool = False,
        quad: bool = False,
        octal: bool = False
    ):
        ...

    def init(
        self, width: int, height: int, bpp: int, buffer_size: int,
        rgb565_byte_swap: bool, cmd_bits: int, param_bits: int, /
    ) -> None:
        ...

    def deinit(self) -> None:
        ...

    def register_callback(self, callback: Callable[[Any, Any], None], /) -> None:
        ...

    def tx_param(self, cmd: int, params: Optional[_BufferType] = None, /) -> None:
        ...

    def tx_color(self, cmd: int, data: _BufferType, start_x: int, start_y: int, end_x: int, end_y: int, rotation: int, last_update: bool, /) -> None:
        ...

    def rx_param(self, cmd: int, params: _BufferType, /) -> None:
        ...

    def get_lane_count(self) -> int:
        ...

    def allocate_framebuffer(self, size: int, caps: int, /) -> Union[None, memoryview]:
        ...

    def free_framebuffer(self, framebuffer: memoryview, /) -> None:
        ...
