class RGBBus:

    def __init__(
        self,
        *,
        hsync: int,
        vsync: int,
        de: int,
        pclk: int,
        data0: int,
        data1: int,
        data2: int,
        data3: int,
        data4: int,
        data5: int,
        data6: int,
        data7: int,
        data8: int = -1,
        data9: int = -1,
        data10: int = -1,
        data11: int = -1,
        data12: int = -1,
        data13: int = -1,
        data14: int = -1,
        data15: int = -1,
        freq: int = 8000000,
        hsync_front_porch: int = 0,
        hsync_back_porch: int = 0,
        hsync_pulse_width: int = 1,
        hsync_idle_low: bool = False,
        vsync_front_porch: int = 0,
        vsync_back_porch: int = 0,
        vsync_pulse_width: int = 1,
        vsync_idle_low: bool = False,
        de_idle_high: bool = False,
        pclk_idle_high: bool = False,
        pclk_active_low: bool = False,
        disp_active_low: bool = False,
        refresh_on_demand: bool = False,
        rgb565_dither: bool = False
    ):
        ...

    def init(
        self, width: int, height: int, bpp: int, buffer_size: int,
        rgb565_byte_swap: bool, cmd_bits: int, param_bits: int, /
    ) -> None:
        ...

    def deinit(self) -> None:
        ...

    def register_callback(self, callback: Callable[[Any, Any], None], /) -> None:
        ...

    def tx_param(self, cmd: int, params: Optional[_BufferType] = None, /) -> None:
        ...

    def tx_color(self, cmd: int, data: _BufferType, start_x: int, start_y: int, end_x: int, end_y: int, rotation: int, last_update: bool, /) -> None:
        ...

    def rx_param(self, cmd: int, params: _BufferType, /) -> None:
        ...
    
    def get_lane_count(self) -> int:
        ...

    def allocate_framebuffer(self, size: int, caps: int, /) -> Union[None, memoryview]:
        ...

    def free_framebuffer(self, framebuffer: memoryview, /) -> None:
        ...